-- Test add_surroundings_highlight
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(12);

set search_path to camper, public;

select has_function('camper', 'add_surroundings_highlight', array['integer', 'integer', 'text', 'text']);
select function_lang_is('camper', 'add_surroundings_highlight', array['integer', 'integer', 'text', 'text'], 'sql');
select function_returns('camper', 'add_surroundings_highlight', array['integer', 'integer', 'text', 'text'], 'integer');
select isnt_definer('camper', 'add_surroundings_highlight', array['integer', 'integer', 'text', 'text']);
select volatility_is('camper', 'add_surroundings_highlight', array['integer', 'integer', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'add_surroundings_highlight', array ['integer', 'integer', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'add_surroundings_highlight', array ['integer', 'integer', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'add_surroundings_highlight', array ['integer', 'integer', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'add_surroundings_highlight', array ['integer', 'integer', 'text', 'text'], 'authenticator', array[]::text[]);

set client_min_messages to warning;
truncate surroundings_highlight cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
     , (2, 'Company 4', 'XX234', '', '666-666-666', 'b@b', '', '', '', '', '', '', 60, 7, 'FR', 'USD', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (3, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , (4, 2, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

select lives_ok(
	$$ select add_surroundings_highlight(1, 3, 'Highlight A', '<p>What</p>') $$,
	'Should be able to add a surroundings highlight to the first company'
);

select lives_ok(
	$$ select add_surroundings_highlight(2, 4, 'Highlight B', '') $$,
	'Should be able to add a surroundings highlight to the second company'
);

select bag_eq(
	$$ select company_id, media_id, name, description::text from surroundings_highlight $$,
	$$ values (1, 3, 'Highlight A', '<p>What</p>')
	        , (2, 4, 'Highlight B', '')
	$$,
	'Should have added all two surroundings highlight'
);


select *
from finish();

rollback;
